/*
 * Lsystem3DForm.java
 *
 * Created on Sobota, 2004, november 6, 18:00
 */

/**
 *
 * @author  Peter Ovarik, Marek Mizanin
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import javax.naming.*;
import javax.swing.*;
import javax.swing.border.*; 
import javax.swing.text.*;
import java.io.*;
import lsystem.*;
import lsystem.generovanie.*;
import graphics.math.v;
import javax.swing.ImageIcon.*;
import java.net.URL;
import jazyk.*;

public class Lsystem3DForm extends javax.swing.JFrame implements WindowListener, ActionListener
{
	public Lsystem3DForm() 
    {
        initComponents();
		this.setTitle("3D Lsystems java");
    }
	
    Nastavenia dial_nast;
    
    boolean def_ground=false;
        
    JButton Generuj;
    //JButton Stop;
	JTextField text_iter;
	JLabel lab_iter;
	JLabel lab_lsys;
	JButton minus_iter;
	JButton plus_iter;
	JTextArea text_lsystem;
    JScrollPane text_lsystem_scroll;
	JTextArea text_vystup;
    JScrollPane text_vystup_scroll;
    JTextArea text_homo;
    JScrollPane text_homo_scroll;
	JLabel lab_vyst;
    JLabel lab_info;
    JButton reset;
	JButton about_autors;
	//JLabel lab_dlzka_ret;
	//JTextField text_max_dl;
    JLabel lab_homo;
    JComboBox combo;
    JLabel lab_kategoria;
    JComboBox kategoria;
    ButtonGroup vyber_jazyka;
    JRadioButton jazyk_english;
    JRadioButton jazyk_slovak;
	
	MyPanel pan;		// hlavny panel
	JCheckBox rotuj;
    JCheckBox zobr_ret;
    JCheckBox zobr_homo;
    JCheckBox antialiasing;
	JCheckBox valce;
	JCheckBox pouzi_hom;
    JCheckBox zobr_lsys;
    JButton nastavenia;
    Jazyk j;
    Click click;
    JLabel dlzka_ret;
    JLabel dlzka_ret1;
    
	Subory lsys_priklady = new Subory();
    Subory.Lsystem[] priklady;
	Lsystem lsys  = new Lsystem();
    int gen = 0;
    public boolean[] generuje_sa = {false};
    Image image;
    ImageIcon icona_stop = null;
    
    //////////////////////////////////////////////////////////////////////////
    // nastavenie GUI
    
    // velkost okna appletu
    int size_x = 657;
    int size_y = 460;
    
    // pozicia a dlzka kombo boxov
    int combo_x = 60;
    int combo_y = 10;
    int combo_dlzka = 160;
    int combo_font_size = 11;
        
    // pozicia popisu k kombo boxom
    int com_popis_x = 10;
    int com_popis_y = 10;
        
    // pozicia check boxov pre natavenie textovych poli
    int check_lsys_x = 222;
    int check_lsys_y = 7;
     
    // pozicia pre textove polia
    int text_areas_x = 10;
    int text_areas_y = 65;
    int text_areas_size_x = (int)(/*329*/360*size_x/740);//330
    int text_areas_size_y = size_y-text_areas_x-text_areas_y-12;
    
    // pozicia pre prvky: Nastavenie, Rotuj, Atialiasing, Valce, Homomorfizmus
    int check_x = size_x-293;//size_x-270;//360;
    int check_y = 10;
    
    // pozicia pre prvky: iter, textove pole iter, Generuj, 0, -1, +1
    int poz_x = size_x-309;//size_x-270;//360;//350;
    int poz_y = 49;
        
    // koniec nastavenia GUI
    /////////////////////////////////////////////////////////////////////////
    
    int slovak;
    int english;
        
    public void initComponents()
	{
		setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        this.setResizable(false);
/*        try 
        {
	   		UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
  		} catch(Exception e) {}
*/   	
        dial_nast = new Nastavenia();
        dial_nast.setResizable(false);
        dial_nast.form = this;
        //dial_nast.setLocation(240,150);
        dial_nast.setLocationRelativeTo(this);
        
        slovak=0;
        english=1;
        j = new Jazyk();
        
        image = null;
        icona_stop = null;
        lab_info = new JLabel("");
        lab_info.setFont(new Font(lab_info.getFont().getName(),Font.ITALIC | Font.BOLD,11));
    	Generuj = new JButton();
        reset = new JButton();
        //Generuj.setFont(new Font(Generuj.getName(),Font.BOLD,11));
        text_iter = new JTextField("1");
  		lab_iter = new JLabel();
        lab_iter.setFont(new Font(lab_iter.getName(),Font.PLAIN,11));
  		lab_lsys = new JLabel();
        lab_lsys.setFont(new Font(lab_lsys.getName(),Font.PLAIN,11));
  		minus_iter = new JButton("-1");
  		plus_iter = new JButton("+1");
  		text_lsystem = new JTextArea();
  		text_lsystem_scroll = new JScrollPane(text_lsystem);
  		text_vystup = new JTextArea();
  		text_vystup_scroll = new JScrollPane(text_vystup);
        text_homo = new JTextArea();
        text_homo_scroll = new JScrollPane(text_homo);
  		lab_vyst = new JLabel();
        lab_vyst.setFont(new Font(lab_vyst.getName(),Font.PLAIN,11));
  		//lab_dlzka_ret = new JLabel("Max. dlzka:");
        lab_homo = new JLabel();
        lab_homo.setFont(new Font(lab_homo.getName(),Font.PLAIN,11));
  		//text_max_dl = new JTextField("1000000");
  		click = new Click();
        Wheel wheel = new Wheel();
        combo = new JComboBox();
        kategoria = new JComboBox();
        nastavenia = new JButton();
        jazyk_english = new JRadioButton("English",false);
        jazyk_slovak = new JRadioButton("Slovensky",true);
		about_autors = new JButton("a");
        vyber_jazyka = new ButtonGroup();
        dlzka_ret = new JLabel();
        dlzka_ret1 = new JLabel("0");
        
        //jazyk.
        //Stop = new JButton("Stop");
        
        //Stop.addActionListener(click);
     	Generuj.addActionListener(click);     	
     	minus_iter.addActionListener(click);     	
     	plus_iter.addActionListener(click);
        combo.addActionListener(click);
        combo.addMouseWheelListener(wheel);
        kategoria.addActionListener(click);
        kategoria.addMouseWheelListener(wheel);
        nastavenia.addActionListener(click);
        reset.addActionListener(click);
        jazyk_english.addActionListener(click);
        jazyk_slovak.addActionListener(click);
		about_autors.addActionListener(click);
             
       	getContentPane().setLayout(null);
        //getContentPane().add(Stop); Stop.setBounds(445,42,84,23);
		getContentPane().add(lab_info); lab_info.setBounds(text_areas_x+text_areas_size_x+8/*poz_x-2*/,67,200,20);
		// + 0
		// - 49
		// 0 2*49
		// Generuj  141
		// lab_iter 141+80
		// text_iter 141+80+50
  		getContentPane().add(plus_iter); plus_iter.setBounds(poz_x,poz_y,46,20);
        plus_iter.setFont(new Font(plus_iter.getName(),Font.PLAIN,11));
				
		getContentPane().add(minus_iter); minus_iter.setBounds(poz_x+49,poz_y,46,20);
        minus_iter.setFont(new Font(minus_iter.getName(),Font.PLAIN,11));
		
		getContentPane().add(reset); reset.setBounds(poz_x+2*49,poz_y,40,20);
        reset.setFont(new Font(reset.getName(),Font.PLAIN,11));
        
		getContentPane().add(Generuj); Generuj.setBounds(poz_x+141,poz_y,80,20);
		getContentPane().add(lab_iter); lab_iter.setBounds(poz_x+141+85,poz_y,40,20);
		getContentPane().add(text_iter); text_iter.setBounds(poz_x+141+85+40,poz_y,34,20);
		//text_iter.setBackground(white);

  		getContentPane().add(text_lsystem_scroll); text_lsystem_scroll.setBounds(12,80,325,421);//200
  		//text_lsystem.setBorder(BorderFactory.createMatteBorder(1,1,1,1,Color.black));
 		//text_lsystem.setBackground(white);
  		getContentPane().add(lab_lsys); lab_lsys.setBounds(com_popis_x,com_popis_y+28,60,20);
  		getContentPane().add(lab_vyst); lab_vyst.setBounds(12,287,150,20);
  		text_vystup.setEditable(false); text_vystup.setLineWrap(true);
  		getContentPane().add(text_vystup_scroll); text_vystup_scroll.setBounds(12,308,325,158);
        getContentPane().add(lab_homo); //lab_homo.setBounds(380,292,350,20);
        text_homo.setEditable(false); text_homo.setLineWrap(true);
        getContentPane().add(text_homo_scroll); //text_homo_scroll.setBounds(380,310,350,150);
  		getContentPane().add(nastavenia); nastavenia.setBounds(check_x,check_y+3,88,22);
        nastavenia.setFont(new Font(nastavenia.getName(),Font.PLAIN,11));
        
        vyber_jazyka.add(jazyk_english);
        vyber_jazyka.add(jazyk_slovak);
        getContentPane().add(jazyk_english); jazyk_english.setBounds(size_x-162,size_y-22,60,20);
        jazyk_english.setFont(new Font(jazyk_english.getName(),Font.PLAIN,11));
        
        getContentPane().add(jazyk_slovak); jazyk_slovak.setBounds(size_x-82,size_y-22,75,20);
        jazyk_slovak.setFont(new Font(jazyk_slovak.getName(),Font.PLAIN,11));
        
		getContentPane().add(dlzka_ret); dlzka_ret.setBounds(text_areas_x,size_y-22,75,20);
        dlzka_ret.setFont(new Font(dlzka_ret.getName(),Font.PLAIN,11));
        getContentPane().add(dlzka_ret1); dlzka_ret1.setBounds(text_areas_x+73,size_y-22,80,20);
        dlzka_ret1.setFont(new Font(dlzka_ret1.getName(),Font.PLAIN,11));
        
	//	getContentPane().add(about_autors); about_autors.setBounds(size_x-300,size_y-20,110,18);
		getContentPane().add(about_autors); about_autors.setBounds(size_x-16,2,15,15);
        about_autors.setFont(new Font(about_autors.getName(),Font.PLAIN,10));		
		
        //text_vystup.setBorder(BorderFactory.createMatteBorder(1,1,1,1,Color.black));
  		//text_vystup.setBackground(white);
  		
		//getContentPane().add(lab_dlzka_ret); lab_dlzka_ret.setBounds(347,45,65,20);
  		//getContentPane().add(text_max_dl); text_max_dl.setBounds(419,45,65,20);
        
        combo.setMaximumRowCount(21);
		getContentPane().add(combo); combo.setBounds(combo_x,combo_y+30,combo_dlzka,20);
        combo.setFont(new Font(combo.getName(),Font.PLAIN,combo_font_size));
        kategoria.setMaximumRowCount(22);
        getContentPane().add(kategoria); kategoria.setBounds(combo_x,combo_y,combo_dlzka,20);
        kategoria.setFont(new Font(kategoria.getName(),Font.PLAIN,11));
        lab_kategoria = new JLabel("Kategoria:");
        lab_kategoria.setFont(new Font(lab_kategoria.getName(),Font.PLAIN,11));
        getContentPane().add(lab_kategoria); lab_kategoria.setBounds(com_popis_x,com_popis_y,60,20);
                
		pan = new MyPanel();
		pan.form = this;
        getContentPane().add(pan);
		pan.setBounds(text_areas_x+text_areas_size_x+8,text_areas_y+20,size_x-text_areas_x-text_areas_size_x-18,text_areas_size_y-1-20/*36*/);//388 385
                
        rotuj = new JCheckBox("Rotovat");
        rotuj.setFont(new Font(rotuj.getName(),Font.PLAIN,11));
		rotuj.addActionListener(click);
		getContentPane().add(rotuj);
		rotuj.setBounds(check_x+100,check_y-4, 68, 20);
        pan.Generuj = Generuj;
        pan.lab_info = lab_info;
        pan.generuje_sa = generuje_sa;
                
        antialiasing = new JCheckBox("Antialiasing");
        antialiasing.setFont(new Font(antialiasing.getName(),Font.PLAIN,11));
		antialiasing.addActionListener(click);
		getContentPane().add(antialiasing);
		antialiasing.setBounds(check_x+100,check_y+12,83,20);
		
		valce = new JCheckBox("Valce");
        valce.setFont(new Font(valce.getName(),Font.PLAIN,11));
		valce.addActionListener(click);
		getContentPane().add(valce);
		valce.setBounds(check_x+185,check_y-4, 70, 20);
		valce.setSelected(true);
		
		pouzi_hom = new JCheckBox("Homomorf.");
        pouzi_hom.setFont(new Font(pouzi_hom.getName(),Font.PLAIN,11));
		pouzi_hom.addActionListener(click);
		getContentPane().add(pouzi_hom);
		pouzi_hom.setBounds(check_x+185,check_y+12, /*85*/120, 20);
		pouzi_hom.setSelected(true);
	//	pouzi_hom.setFont(new Font(pouzi_hom.getFont().getName(),Font.PLAIN,10));
        
        zobr_lsys = new JCheckBox("Editovat L-system");
        zobr_lsys.setFont(new Font(zobr_lsys.getName(),Font.PLAIN,11));
        zobr_lsys.addActionListener(click);
        getContentPane().add(zobr_lsys);
        zobr_lsys.setBounds(check_lsys_x,check_lsys_y, 120, 19);//260,49, 135, 19
        zobr_lsys.setSelected(true);
        
        zobr_ret = new JCheckBox("Zobrazovat retazec");
        zobr_ret.setFont(new Font(zobr_ret.getName(),Font.PLAIN,11));
        zobr_ret.addActionListener(click);
        getContentPane().add(zobr_ret);
		zobr_ret.setBounds(check_lsys_x,check_lsys_y+37, 122, 19);
        
        zobr_homo = new JCheckBox("Zobraz. homomorf.");
        zobr_homo.setFont(new Font(zobr_homo.getName(),Font.PLAIN,11));
        zobr_homo.addActionListener(click);
        getContentPane().add(zobr_homo);
		zobr_homo.setBounds(check_lsys_x,check_lsys_y+19, 120, 19);//260,30, 135, 19
        
        jazyk_slovak.setSelected(true);
        Nastav_jazyk(slovak);
        
/*        jazyk_english.setSelected(true);
        Nastav_jazyk(english);
*/        
        /*for(int i=0; i<lsys_priklady.kategorie[0].priklady.length; i++)
        {
            combo.addItem(makeObj(lsys_priklady.kategorie[0].priklady[i].popis));
        }*/
		this.setSize(size_x+7, size_y+32);
        zobr_ret.setSelected(true);
        zobraz_ret(true);
    //    lsys.Ciary();
		lsys.Valce();
		
        
        priklady = lsys_priklady.kategorie[0].priklady;
      /*  for(int i=0; i<priklady.length; i++)
        {
            combo.addItem(makeObj(priklady[i].popis));
        }
        for(int i=0; i<lsys_priklady.kategorie.length; i++)
        {
            kategoria.addItem(makeObj(lsys_priklady.kategorie[i].nazov));
        }*/
		combo.setSelectedIndex(0);
        
        
        pan.lsys = lsys;
		pan.rotuj = rotuj.isSelected();
		pan.valce = valce.isSelected();
		lsys.pouzi_hom = pouzi_hom.isSelected();
		pan.start();
        //pan.stop();
        //pan.validate();
        //pan.setVisible(true);
    }

    private Object makeObj(final String item)
    {
        return new Object() { public String toString() { return item; } };
    }
    
    class Wheel implements MouseWheelListener
    {
        public void mouseWheelMoved(MouseWheelEvent udalost)
        {
            if(udalost.getSource() == combo)
            {
                if(udalost.getWheelRotation()<0)
                {
                    if(combo.getSelectedIndex()>0) combo.setSelectedIndex(combo.getSelectedIndex()-1);
                }
                else
                {
                    if(combo.getSelectedIndex()<combo.getItemCount()-1) combo.setSelectedIndex(combo.getSelectedIndex()+1);
                }
            }
            
            if(udalost.getSource() == kategoria)
            {
                if(udalost.getWheelRotation()<0)
                {
                    if(kategoria.getSelectedIndex()>0) kategoria.setSelectedIndex(kategoria.getSelectedIndex()-1);
                }
                else
                {
                    if(kategoria.getSelectedIndex()<kategoria.getItemCount()-1) kategoria.setSelectedIndex(kategoria.getSelectedIndex()+1);
                }
            }
        }
        
    }
    
    void zobraz_ret(boolean set)
    {
        if(set)
        {
            if(zobr_homo.getSelectedObjects()!=null)
            {
                text_lsystem_scroll.reshape(text_areas_x,text_areas_y,text_areas_size_x,(int)(0.341*text_areas_size_y));
                lab_homo.reshape(text_areas_x,text_areas_y+(int)(/*274*/273*text_areas_size_y/396),text_areas_size_x,20);
                text_homo_scroll.reshape(text_areas_x,text_areas_y+(int)(296*text_areas_size_y/396),text_areas_size_x,(int)(100*text_areas_size_y/396));
                text_vystup_scroll.reshape(text_areas_x,text_areas_y+(int)(155*text_areas_size_y/396),text_areas_size_x,(int)(0.303*text_areas_size_y));
                lab_vyst.reshape(text_areas_x,text_areas_y+(int)(/*133*/132*text_areas_size_y/396),150,20);
            }
            else
            {
                text_lsystem_scroll.reshape(text_areas_x,text_areas_y,text_areas_size_x,(int)(0.543*text_areas_size_y));
                text_vystup_scroll.reshape(text_areas_x,text_areas_y+(int)(238*text_areas_size_y/396),text_areas_size_x,(int)(0.399*text_areas_size_y));
                lab_vyst.reshape(text_areas_x,text_areas_y+(int)(/*217*/214*text_areas_size_y/396),150,20);
            }
            text_vystup_scroll.setVisible(true);
            lab_vyst.setVisible(true);
        }
        else
        {
            text_vystup_scroll.setVisible(false);
            lab_vyst.setVisible(false);
            if(zobr_homo.getSelectedObjects()!=null)
            {
                text_lsystem_scroll.reshape(text_areas_x,text_areas_y,text_areas_size_x,(int)(215*text_areas_size_y/396));
                lab_homo.reshape(text_areas_x,text_areas_y+(int)(/*217*/214*text_areas_size_y/396),text_areas_size_x,20);
                text_homo_scroll.reshape(text_areas_x,text_areas_y+(int)(238*text_areas_size_y/396),text_areas_size_x,(int)(158*text_areas_size_y/396));
            }
            else
            {
                text_lsystem_scroll.reshape(text_areas_x,text_areas_y,text_areas_size_x,text_areas_size_y);
            }
       }
        this.validate();
    }
    
    void zobraz_homo(boolean set)
    {
        if(set)
        {
            if(zobr_ret.getSelectedObjects()!=null)
            {
                text_lsystem_scroll.reshape(text_areas_x,text_areas_y,text_areas_size_x,(int)(0.341*text_areas_size_y));
                text_vystup_scroll.reshape(text_areas_x,text_areas_y+(int)(155*text_areas_size_y/396),text_areas_size_x,(int)(0.303*text_areas_size_y));
                lab_vyst.reshape(text_areas_x,text_areas_y+(int)(/*135*/132*text_areas_size_y/396),150,20);
                lab_homo.reshape(text_areas_x,text_areas_y+(int)(/*276*/273*text_areas_size_y/396),text_areas_size_x,20);
                text_homo_scroll.reshape(text_areas_x,text_areas_y+(int)(296*text_areas_size_y/396),text_areas_size_x,(int)(0.253*text_areas_size_y));
            }
            else
            {
                text_lsystem_scroll.reshape(text_areas_x,text_areas_y,text_areas_size_x,(int)(0.543*text_areas_size_y));
                lab_homo.reshape(text_areas_x,text_areas_y+(int)(/*217*/214*text_areas_size_y/396),text_areas_size_x,20);
                text_homo_scroll.reshape(text_areas_x,text_areas_y+(int)(238*text_areas_size_y/396),text_areas_size_x,(int)(0.399*text_areas_size_y));
            }
            text_homo_scroll.setVisible(true);
            lab_homo.setVisible(true);
        }
        else
        {
            text_homo_scroll.setVisible(false);
            lab_homo.setVisible(false);
            if(zobr_ret.getSelectedObjects()!=null)
            {
                text_lsystem_scroll.reshape(text_areas_x,text_areas_y,text_areas_size_x,(int)(0.543*text_areas_size_y));
                lab_vyst.reshape(text_areas_x,text_areas_y+(int)(/*217*/214*text_areas_size_y/396),150,20);
                text_vystup_scroll.reshape(text_areas_x,text_areas_y+(int)(238*text_areas_size_y/396),text_areas_size_x,(int)(0.399*text_areas_size_y));
            }
            else
            {
                text_lsystem_scroll.reshape(text_areas_x,text_areas_y,text_areas_size_x,text_areas_size_y);
            }
        }
        this.validate();
    }
    
	class Click implements ActionListener, Runnable
  	{
        Thread thread;
        //boolean generuje_sa = false;
        boolean dokoncit = false, vykresluje_sa = false;
        boolean analyzuje_sa = false;
        int iteracia=0,gen1=0,iter1=0;
        String zaloha_ret;
		boolean resetCamera=false;
        public void actionPerformed(ActionEvent udalost)
        {
            if(udalost.getSource() == Generuj)
            {  
				resetCamera = true;
                iteracia = OverIteraciu();
                if(iteracia>=0)
                {
                    gen=0; 
                    //GenerujRetazec(iteracia,0);
                    if(!generuje_sa[0] && !pan.vykresluje_sa) 
                    {
                        //dokoncit = false;
                        stop(); 
                        generuje_sa[0]=true;
                        //Generuj.setText("Stop");
                        //lab_info.setText("Generuje sa retazec");
                        start();
                    }
                    else
                    {
                        //dokoncit = true;
                        if(generuje_sa[0])
                        {
                            stop();
                            lsys.level = -1;
                            text_iter.setText(String.valueOf(iter1));
                            text_vystup.setText(zaloha_ret);
                            if(analyzuje_sa)
                            {
                                //pan.lsys = new Lsystem();
                                if(jazyk_slovak.isSelected()) lab_info.setText(j.slovak.info_prerusena_interpr_ret);
                                else lab_info.setText(j.english.info_prerusena_interpr_ret);
                            }
                            else
                            {
                                lab_info.setText("");
                                //lab_info.setText("Prerusene pri generovani");
                            }
                            
                        }
                        else
                        {
                            stop();
                            pan.stop();
                            //pan.lsys = new Lsystem();
                            pan.set_vypis = false;
                            pan.vykresluje_sa = false;
                            lab_info.setText(/*"Prerusene vykrelovanie!"*/"");
                        }
                        generuje_sa[0] = false;
                        Generuj.setIcon(null);
                        Generuj.setText("Generuj");
                        //lab_info.setText("");
                    }
                }
                gen1 = 1;
            }
    		
            if(udalost.getSource() == minus_iter)
            {
				resetCamera = false;
                iteracia = OverIteraciu();
                iteracia--;
                if(iteracia>=0)
                {
                    text_iter.setText(String.valueOf(iteracia));
                    //this.GenerujRetazec(iteracia,gen);
                    //Generuj.setText("Stop");
                    //lab_info.setText("Generuje sa retazec");
                    if(!generuje_sa[0]) 
                    {
                        //dokoncit = false;
                        stop(); 
                        generuje_sa[0]=true;
                        start();
                    }
                    else
                    {
                        //dokoncit = true;
                        stop();
                        lsys.level=-1;
                        start();
                    }
                    gen1=1;
                }
            }
    		
            if(udalost.getSource() == plus_iter)
            {
				resetCamera = false;
                iteracia = OverIteraciu();
                iteracia++;
                if(iteracia>=0)
                {
                    text_iter.setText(String.valueOf(iteracia));
                    //this.GenerujRetazec(iteracia,gen);
                    if(!generuje_sa[0]) 
                    {
                        //dokoncit = false;
                        stop(); 
                        generuje_sa[0]=true;
                        //Generuj.setText("Stop");
                        //lab_info.setText("Generuje sa retazec");
                        start();
                    }
                    else
                    {
                        dokoncit = true;
                        /*stop();
                        lsys.level=-1;
                        start();*/
                    }
                    gen1=1;
                }
            }
            
            /*if(udalost.getSource() == Stop)
            {
                stop();
                pan.stop();
                pan.lsys = new Lsystem();
                //pan.start();
                if(generuje_sa)
                {
                    stop();
                    lsys.level = -1;
                    text_iter.setText(String.valueOf(iter1));
                    text_vystup.setText(zaloha_ret);
                    generuje_sa = false;
                }
                
            }*/
            
            if(udalost.getSource() == combo)
            {
				resetCamera = true;
                int index = combo.getSelectedIndex();
                if(index<0) index = 0;
                //JOptionPane.showMessageDialog(null,String.valueOf(index),"Chyba",JOptionPane.ERROR_MESSAGE);
                text_lsystem.setText(priklady[index].lsystem);
                text_lsystem.setSelectionStart(0);
                text_lsystem.setSelectionEnd(0);
                //text_lsystem_scroll.setS
                if(dial_nast.bool_default_iter) iteracia = priklady[index].default_iteracia;
                else iteracia = 0;
                               
                if(dial_nast.bool_kreslit_zem)
                {
                    pan.ground=priklady[index].draw_ground; // tu hodit zem
                }
                else pan.ground=false;
                
                if(!dial_nast.bool_farba_pozadia)
                {
                    pan.bgcolor=priklady[index].bg_color; // tu hodit farbu pozadia
                }
                text_iter.setText(String.valueOf(iteracia));
                gen=0;
                //Generuj.setText("Stop");
                //lab_info.setText("Generuje sa retazec");
                
                if(!generuje_sa[0]) 
                {
                    //dokoncit = false;
                    //stop(); 
                    generuje_sa[0]=true;
                    //start();
                }
                else
                {
                    //dokoncit = true;
                    //stop();
                    //pan.stop();
                    lsys.level=-1;
                    //start();
                }
                
                pan.stop();
                stop();
                if(dial_nast.bool_default_valce)
                {
                    boolean def_valce=priklady[index].valce; //tu hodit valce
                    
                    pan.valce=def_valce;
                    valce.setSelected(def_valce);
                    if(def_valce) lsys.Valce();
                    else lsys.Ciary();
                }
                start();
                gen1=1;
            }
            
            if(udalost.getSource() == kategoria)
            {
                combo.removeAllItems();
                //combo.setSelectedIndex(0);
                //combo.removeAll();
                int index = kategoria.getSelectedIndex();
                priklady = lsys_priklady.kategorie[index].priklady;
                for(int i=0; i<priklady.length; i++)
                {
					if(jazyk_english.isSelected() && priklady[i].popis_eng.length()>0)
						combo.addItem(makeObj(priklady[i].popis_eng));
					else
						combo.addItem(makeObj(priklady[i].popis));
                }
                //combo.setSelectedIndex(0);
            }
			
			if(udalost.getSource() == rotuj)
			{
				pan.rotuj = rotuj.getSelectedObjects()!=null;
				if(pan.rotuj)
				{
					pan.stop();
					pan.start();
				}
				else
				{
					pan.stop();
					pan.start();					
				}
			}
            
            if(udalost.getSource() == antialiasing)
			{
				try{
                pan.antialiasing = antialiasing.getSelectedObjects()!=null;
				if(pan.rotuj)
				{
					pan.stop();
					pan.start();
				}
				else
				{
					pan.stop();
					pan.start();					
				}
                }catch(OutOfMemoryError e) 
                {
                    try{wait(100);} catch(Exception er) {}
                    if(jazyk_slovak.isSelected()) JOptionPane.showMessageDialog(dial_nast.applet,j.slovak.chyba_malo_pamati,j.slovak.chyba,JOptionPane.ERROR_MESSAGE);
                    else JOptionPane.showMessageDialog(dial_nast.applet,j.english.chyba_malo_pamati,j.english.chyba,JOptionPane.ERROR_MESSAGE);
                    pan.stop();
                    stop();
                    iteracia=0;
                    start();
                    return;
                }
			}
			if(udalost.getSource() == valce)
			{
				try{
                pan.valce = valce.getSelectedObjects()!=null;
				if(pan.valce)
					lsys.Valce();
				else
					lsys.Ciary();
                }catch (OutOfMemoryError e) 
                {
                    try{wait(100);} catch(Exception er) {}
                    if(jazyk_slovak.isSelected()) JOptionPane.showMessageDialog(dial_nast.applet,j.slovak.chyba_malo_pamati,j.slovak.chyba,JOptionPane.ERROR_MESSAGE);
                    else JOptionPane.showMessageDialog(dial_nast.applet,j.english.chyba_malo_pamati,j.english.chyba,JOptionPane.ERROR_MESSAGE);
                    pan.stop();
                    stop();
                    iteracia=0;
                    start();
                    return;
                }
                if(pan.rotuj)
				{
					pan.stop();
					pan.start();
				}
				else
				{
					pan.stop();
					pan.start();			
				}
			}
            
            if(udalost.getSource() == zobr_ret)
            {
                if(zobr_ret.isSelected()) zobraz_ret(true);
                else zobraz_ret(false);
            }
            
            if(udalost.getSource() == zobr_homo)
            {
                if(zobr_homo.isSelected()) zobraz_homo(true);
                else zobraz_homo(false);
            }
            
            if(udalost.getSource() == zobr_lsys)
            {
                if(zobr_lsys.isSelected())
                {
                    text_lsystem_scroll.setVisible(true);
                    zobr_ret.setEnabled(true);
                    zobr_homo.setEnabled(true);
                    lab_vyst.setVisible(true);
                    lab_homo.setVisible(true);
                    if(zobr_ret.isSelected()) text_vystup_scroll.setVisible(true);
                    if(zobr_homo.isSelected()) text_homo_scroll.setVisible(true);
                    pan.stop();
                    pan.setBounds(text_areas_x+text_areas_size_x+8,text_areas_y+20,size_x-text_areas_x-text_areas_size_x-18,text_areas_size_y-1-20/*36*/);
                    lab_info.setBounds(text_areas_x+text_areas_size_x+8/*poz_x-2*/,67,200,20);
                    pan.start();
                }
                else
                {
                    text_lsystem_scroll.setVisible(false);
                    zobr_ret.setEnabled(false);
                    zobr_homo.setEnabled(false);
                    lab_vyst.setVisible(false);
                    lab_homo.setVisible(false);
                    text_vystup_scroll.setVisible(false);
                    text_homo_scroll.setVisible(false);
                    pan.stop();
                    pan.setBounds(text_areas_x,text_areas_y+13,size_x-text_areas_x-10,text_areas_size_y-4-10/*30*/);
                    lab_info.setBounds(220,60,200,20);
                    pan.start();
                }
            }
			if(udalost.getSource() == pouzi_hom)
			{
				try{
                lsys.pouzi_hom = pouzi_hom.isSelected();
				if(pan.valce)
					lsys.Valce();
				else
					lsys.Ciary();
				if(pan.rotuj)
				{
					pan.stop();
					pan.start();
				}
				else
				{
					pan.stop();
					pan.start();			
				}
                }catch (OutOfMemoryError e) 
                {
                    try{wait(100);} catch(Exception er) {}
                    if(jazyk_slovak.isSelected()) JOptionPane.showMessageDialog(dial_nast.applet,j.slovak.chyba_malo_pamati,j.slovak.chyba,JOptionPane.ERROR_MESSAGE);
                    else JOptionPane.showMessageDialog(dial_nast.applet,j.english.chyba_malo_pamati,j.english.chyba,JOptionPane.ERROR_MESSAGE);                    
                    pan.stop();
                    stop();
                    iteracia=0;
                    start();
                    return;
                }
			}
            
            if(udalost.getSource() == nastavenia)
            {
                dial_nast.farba_pozadia.setSelected(dial_nast.bool_farba_pozadia);
                dial_nast.zobrazovat_tiene.setSelected(dial_nast.bool_zobrazovat_tiene);
                dial_nast.default_iter.setSelected(dial_nast.bool_default_iter);
                dial_nast.kreslit_zem.setSelected(dial_nast.bool_kreslit_zem);
                dial_nast.default_valce.setSelected(dial_nast.bool_default_valce);
                dial_nast.urychlovanie.setSelected(dial_nast.bool_urychlovanie);
                dial_nast.Bg_color.setBackground(new Color(dial_nast.int_bg_color));
                dial_nast.Bg_color.setEnabled(dial_nast.bool_farba_pozadia);
                dial_nast.show();
            }
            
            if(udalost.getSource() == reset)
            {
                resetCamera = false;
                pan.stop();
                stop();
                iteracia = 0;
                gen=1;
                text_iter.setText(String.valueOf(iteracia));
                start();
            }
            
            if(udalost.getSource() == jazyk_english)
            {
                if(jazyk_english.isSelected())
                {
                    Nastav_jazyk(english);
                }
            }
            
            if(udalost.getSource() == jazyk_slovak)
            {
                if(jazyk_slovak.isSelected())
                {
                    Nastav_jazyk(slovak);
                }     
            }
          
			if(udalost.getSource() == about_autors)
			{
				if(jazyk_english.isSelected())
					JOptionPane.showMessageDialog(dial_nast.form,
					"3D_Lsystems java applet\n\n"+
					"\tBiocybernetics, 2004/2005\n"+
					"\tDepartment of Cybernetics & AI\n"+
					"\tFaculty of Elec. Eng. & Informatics\n"+
					"\tUniversity of Technology in Koice, Slovakia\n\n"+
					"Authors:\n"+
					"\tMarek Mianin\r\nPeter Ovarik"
					,"About applet",JOptionPane.INFORMATION_MESSAGE);
				else
					JOptionPane.showMessageDialog(dial_nast.form,
					"3D_Lsystems java applet\n\n"+
					"\tZadanie z predmetu Biokybernetika, 2004/2005\n"+
					"\tKatedra kybernetiky a umelej inteligencie\n"+
					"\tFEI TU Kosice\n\n"+
					"Autori:\n"+
					"\tMarek Mianin\r\nPeter Ovarik"
					,"O applete",JOptionPane.INFORMATION_MESSAGE);
			}
        }
        
        int OverIteraciu()
        {
            int iteracia;
            try 
            {
                iteracia = Integer.parseInt(text_iter.getText());
            } 
            catch(Exception e)
            { 
                if(jazyk_slovak.isSelected())
                {
                    JOptionPane.showMessageDialog(dial_nast.applet,j.slovak.chyba_iter1,j.slovak.chyba,JOptionPane.ERROR_MESSAGE);
                }
                else
                {
                    JOptionPane.showMessageDialog(dial_nast.applet,j.english.chyba_iter1,j.english.chyba,JOptionPane.ERROR_MESSAGE);
                }
                return -1;
            }
            if(iteracia<0)
            {
                if(jazyk_slovak.isSelected())
                {
                    JOptionPane.showMessageDialog(dial_nast.applet,j.slovak.chyba_iter2,j.slovak.chyba,JOptionPane.ERROR_MESSAGE);
                }
                else
                {
                    JOptionPane.showMessageDialog(dial_nast.applet,j.english.chyba_iter2,j.english.chyba,JOptionPane.ERROR_MESSAGE);
                }
                
                return -1;
            }
            if(text_lsystem.getText().length()==0)
            {
                text_vystup.setText("");
                return -1;
            }
            
            return iteracia;
        }
        
        int GenerujRetazec(int iteracia, int set)
        {
            int iter=0;
            try{
            int max_dlzka_ret=10000000;
           /* try
            {
                max_dlzka_ret = Integer.parseInt(text_max_dl.getText());
            }
            catch(Exception e) 
            {
                JOptionPane.showMessageDialog(null,"Zadaj platne cele cislo v kolonke \"Max. dlzka\"","Chyba",JOptionPane.ERROR_MESSAGE);
                return iteracia;    				
            }
    			
            if(max_dlzka_ret<1 || max_dlzka_ret>10000000)
            {
                JOptionPane.showMessageDialog(null,"Maximalna dlzka retazca musi byt v rozmedzi hodnot 1 az 10000000","Chyba",JOptionPane.ERROR_MESSAGE);
                return iteracia;
            }*/
            //JOptionPane.showMessageDialog(null,String.valueOf(icona_stop.getImageLoadStatus()),"Chyba",JOptionPane.ERROR_MESSAGE);
            
            if(icona_stop==null) Generuj.setText("Stop");
            else 
            {
                Generuj.setText("");
                Generuj.setIcon(icona_stop);
            }
            //lab_info.setText("Nacitava sa L-system");
            if(jazyk_slovak.isSelected()) lab_info.setText(j.slovak.info_gen_retazec);
            else lab_info.setText(j.english.info_gen_retazec);
            int dlzka_vypisovaneho_ret=10000;
           
            if(set==0) lsys.Nacitaj(text_lsystem.getText());
            lsys.max_dlzka_retazca = max_dlzka_ret;
            
            iter = lsys.Generuj(iteracia);
            
            String vyst_retazec = new String();
            if(lsys.r.length()>dlzka_vypisovaneho_ret)
            {
                vyst_retazec = lsys.r.substring(0,dlzka_vypisovaneho_ret+1);
                vyst_retazec += " ...";
            }
            else vyst_retazec = lsys.r.toString();
            text_vystup.setText(vyst_retazec);
            String dlzka = String.valueOf(lsys.r.length());
            if(jazyk_slovak.isSelected())
            {
                if(lsys.r.length()==1) dlzka+=" znak";
                else if(lsys.r.length()>=2 && lsys.r.length()<=4) dlzka+=" znaky";
                else dlzka+=" znakov";
            }
            dlzka_ret1.setText(dlzka);            
            String vyst_homo = new String();    
            if(lsys.rh.length()>dlzka_vypisovaneho_ret)
            {
                vyst_homo = lsys.rh.substring(0,dlzka_vypisovaneho_ret+1);
                vyst_homo += " ...";
            }
            else vyst_homo = lsys.rh.toString();
            text_homo.setText(vyst_homo);
			
            //Generuj.setText("Stop");
            if(jazyk_slovak.isSelected()) lab_info.setText(j.slovak.info_itrepret_retazec);
            else lab_info.setText(j.english.info_itrepret_retazec);
            pan.stop();
			analyzuje_sa=true;
            lsys.Vytvor();
            pan.lsys = lsys;
            analyzuje_sa=false;
			generuje_sa[0]=false;
            pan.set_vypis = true;
            
			if(resetCamera)
			{
				pan.cam.reset();
				pan.cam.vcp.set(lsys.stred);
				pan.cam.vp.set(v.sub(pan.cam.vcp,v.mul(pan.cam.vd,pan.cam.vpd)));
				pan.modelView.set(pan.cam.getMatrix());
			}
			else
			{
				pan.cam.vp.add(v.sub(lsys.stred,pan.cam.vcp));
				pan.cam.vcp.set(lsys.stred);
				pan.modelView.set(pan.cam.getMatrix());
			}
			pan.start();
            //Generuj.setText("Generuj");
            } catch(OutOfMemoryError error) 
            {
                try{wait(100);} catch(Exception e) {}
                if(jazyk_slovak.isSelected()) JOptionPane.showMessageDialog(dial_nast.applet,j.slovak.chyba_malo_pamati,j.slovak.chyba,JOptionPane.ERROR_MESSAGE);
                else JOptionPane.showMessageDialog(dial_nast.applet,j.english.chyba_malo_pamati,j.english.chyba,JOptionPane.ERROR_MESSAGE);
                pan.stop();
                iteracia=0;
                iter=0;
                return -1;
            }
            return iter;
        }
        
        public void run()
        {
            if(text_vystup.getText().compareTo(j.slovak.info_gen_retazec1)!=0 && text_vystup.getText().compareTo(j.english.info_gen_retazec1)!=0) zaloha_ret = text_vystup.getText();
            if(jazyk_slovak.isSelected()) text_vystup.setText(j.slovak.info_gen_retazec1);
            else text_vystup.setText(j.english.info_gen_retazec1);
            iter1 = GenerujRetazec(iteracia,gen);
            if(iter1<0) {iter1=0; GenerujRetazec(iter1,gen);}
            else
            {
                if(dokoncit)
                {
                    if(jazyk_slovak.isSelected()) text_vystup.setText(j.slovak.info_gen_retazec1);
                    else text_vystup.setText(j.english.info_gen_retazec1);
                    iter1 = GenerujRetazec(iteracia,gen);
                    if(iter1<0) {iter1=0; GenerujRetazec(iter1,gen);}
                }
            }
            dokoncit = false;
            gen=gen1;
            iteracia = iter1;
            text_iter.setText(String.valueOf(iteracia));
            //generuje_sa[0] = false;
        }
        
        public void start()
        {
            if (thread==null)					// check thread
            {
                thread = new Thread(this);		// create thread
                thread.setPriority(2/*Thread.MIN_PRIORITY*/);
                thread.start();               // start thread
            }	
        }
    
        public void stop()
        {
            if (thread!=null && thread.isAlive())		// check thread is valid and alive
            {
                try{thread.stop();}     // stop thread
                catch (SecurityException e) {}
            }
            thread = null;                  // null thread
        }
        
    }
	
    public void Update_settings()
    {
        int index = combo.getSelectedIndex();
        if(index<0) index = 0;
        
        pan.lineModeDrag=dial_nast.bool_urychlovanie;
        pan.shadow=dial_nast.bool_zobrazovat_tiene;
        if(priklady[index].draw_ground) pan.ground=dial_nast.bool_kreslit_zem;
       
        if(dial_nast.bool_farba_pozadia) pan.bgcolor = dial_nast.int_bg_color;
        else pan.bgcolor=priklady[index].bg_color;
        if(dial_nast.bool_default_valce)
        {
            pan.stop();
            pan.valce=priklady[index].valce;
            valce.setSelected(pan.valce);
            if(pan.valce) lsys.Valce();
            else lsys.Ciary();
        }
        /*if(dial_nast.bool_default_iter && click.iteracia!=priklady[index].default_iteracia)
        {
            click.iteracia=priklady[index].default_iteracia;
            click.stop();
            click.start();
        }*/
        //else
        //{
            pan.stop();
            pan.start();
        //}
    }
    
    public void Nastav_jazyk(int jazyk)
    {
        j = new Jazyk();
        
        if(jazyk==slovak)
        {
            lab_kategoria.setText(j.slovak.combo_kategoria_popis);
            lab_lsys.setText(j.slovak.combo_lsystem_popis);
            zobr_lsys.setText(j.slovak.checkBox_lsystem);
            zobr_homo.setText(j.slovak.checkBox_zobr_homo);
            zobr_ret.setText(j.slovak.checkBox_zobr_retaz);
            lab_vyst.setText(j.slovak.text_lsystem_popis);
            lab_homo.setText(j.slovak.text_homo_popis);
            if(Generuj.getIcon()==null) Generuj.setText(j.slovak.button_generuj);
            nastavenia.setText(j.slovak.button_nastavenia);
            reset.setText(j.slovak.button_reset);
            lab_iter.setText(j.slovak.iteracia_popis);
            rotuj.setText(j.slovak.checkBox_rotuj);
            antialiasing.setText(j.slovak.checkBox_antialiasing);
            valce.setText(j.slovak.checkBox_valce);
            pouzi_hom.setText(j.slovak.checkBox_homo);
            dlzka_ret.setText(j.slovak.info_dlzka_retazca);
            dlzka_ret1.setText(String.valueOf(lsys.r.length())+" znakov");
            dial_nast.setTitle(j.slovak.title);
            dial_nast.Zrusit.setText(j.slovak.button_zrusit);
            dial_nast.Pouzit.setText(j.slovak.button_pouzit);
            dial_nast.default_iter.setText(j.slovak.checkBox_default_iter);
            dial_nast.default_valce.setText(j.slovak.checkBox_default_valce);
            dial_nast.farba_pozadia.setText(j.slovak.checkBox_farba);
            dial_nast.kreslit_zem.setText(j.slovak.checkBox_zem);
            dial_nast.urychlovanie.setText(j.slovak.checkBox_urychlovanie);
            dial_nast.zobrazovat_tiene.setText(j.slovak.checkBox_tiene);
        }
        
        if(jazyk==english)
        {
            lab_kategoria.setText(j.english.combo_kategoria_popis);
            lab_lsys.setText(j.english.combo_lsystem_popis);
            zobr_lsys.setText(j.english.checkBox_lsystem);
            zobr_homo.setText(j.english.checkBox_zobr_homo);
            zobr_ret.setText(j.english.checkBox_zobr_retaz);
            lab_vyst.setText(j.english.text_lsystem_popis);
            lab_homo.setText(j.english.text_homo_popis);
            if(Generuj.getText()!="") Generuj.setText(j.english.button_generuj);
            nastavenia.setText(j.english.button_nastavenia);
            reset.setText(j.english.button_reset);
            lab_iter.setText(j.english.iteracia_popis);
            rotuj.setText(j.english.checkBox_rotuj);
            antialiasing.setText(j.english.checkBox_antialiasing);
            valce.setText(j.english.checkBox_valce);
            pouzi_hom.setText(j.english.checkBox_homo);
            dlzka_ret.setText(j.english.info_dlzka_retazca);
            dlzka_ret1.setText(String.valueOf(lsys.r.length()));
            dial_nast.setTitle(j.english.title);
            dial_nast.Zrusit.setText(j.english.button_zrusit);
            dial_nast.Pouzit.setText(j.english.button_pouzit);
            dial_nast.default_iter.setText(j.english.checkBox_default_iter);
            dial_nast.default_valce.setText(j.english.checkBox_default_valce);
            dial_nast.farba_pozadia.setText(j.english.checkBox_farba);
            dial_nast.kreslit_zem.setText(j.english.checkBox_zem);
            dial_nast.urychlovanie.setText(j.english.checkBox_urychlovanie);
            dial_nast.zobrazovat_tiene.setText(j.english.checkBox_tiene);
        }
		
		//	MouseWheelListener mwl[] = kategoria.getMouseWheelListeners();
		
		int sel_index = kategoria.getSelectedIndex();
		if(sel_index<0 || sel_index>=lsys_priklady.kategorie.length)
			sel_index=0;
		ActionListener al[] = kategoria.getActionListeners();
		for(int li=0; li<al.length; li++)
			kategoria.removeActionListener(al[li]);
		
		kategoria.removeAllItems();
		for(int i=0; i<lsys_priklady.kategorie.length; i++)
		{
			if(jazyk==slovak)
				kategoria.addItem(makeObj(lsys_priklady.kategorie[i].nazov));
			else
				kategoria.addItem(makeObj(lsys_priklady.kategorie[i].nazov_eng));
		}
		kategoria.setSelectedIndex(sel_index);
		for(int li=0; li<al.length; li++)
			kategoria.addActionListener(al[li]);
	
		priklady = lsys_priklady.kategorie[sel_index].priklady;
		
		sel_index = combo.getSelectedIndex();
		if(sel_index<0 || sel_index>=priklady.length)
			sel_index=0;
		ActionListener alc[] = combo.getActionListeners();
		for(int li=0; li<alc.length; li++)
			combo.removeActionListener(alc[li]);
		
		combo.removeAllItems();
		for(int i=0; i<priklady.length; i++)
		{
			if(jazyk==english && priklady[i].popis_eng.length()>0)
				combo.addItem(makeObj(priklady[i].popis_eng));
			else
				combo.addItem(makeObj(priklady[i].popis));
		}
		combo.setSelectedIndex(sel_index);
		for(int li=0; li<alc.length; li++)
			combo.addActionListener(alc[li]);
    }
    
	public void start()
  	{
		pan.start();
        //Generuj.setText("Generuj");
        //lab_info.setText("");
        validate();
  	}
	
	public void stop()
	{
		pan.stop();
    }
    
  	public void paint(Graphics g)
	{
		getContentPane().repaint();
	}
    
    public static void main(String[] args)
    {
        Lsystem3DForm a = new Lsystem3DForm();
	//	a.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        a.show();
    }
    
    public void actionPerformed(ActionEvent e) 
    {
        
    }
    
    public void windowActivated(WindowEvent e) 
    {
        
    }
    
    public void windowClosed(WindowEvent e)
    {
        stop();
    }
    
    public void windowClosing(WindowEvent e)
    {
        stop();
    }
    
    public void windowDeactivated(WindowEvent e) {
    }
    
    public void windowDeiconified(WindowEvent e)
    {
        start();
    }
    
    public void windowIconified(WindowEvent e) 
    {
        stop();
    }
    
    public void windowOpened(WindowEvent e)
    {
        start();
    }
}

