/*
 * MyPanel.java
 *
 * Created on Utorok, 2004, oktber 12, 20:41
 */

/**
 *
 * @author  m
 */

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.applet.Applet;
import java.util.*;
import javax.swing.*;
import graphics.math.*;
import graphics.device.*;
import graphics.geometry.*;
import lsystem.*;
import jazyk.*;

public class MyPanel extends JPanel implements Runnable, ImageProducer, MouseListener, MouseMotionListener
{
	int _width;
	int _height;
	Image _image;
	Thread _thread;
	ImageConsumer _consumer;
	DirectColorModel _model;
	int frame = 0;
	float fps = 100.f;
	public boolean flat=false;
	public boolean pause=false;
	public Lsystem lsys=null;
	public boolean rotuj=false;
	mat modelView = new mat();
	public Camera cam = new Camera();
	vi mp_start = new vi(0,0);
	vi mp_actual = new vi(0,0);
	vi mp = new vi(0,0);
	public boolean antialiasing=false;
	public boolean valce = false;
	public boolean mouseDrag=false;
	public boolean lineModeDrag=true;
    public boolean vykresluje_sa = false, set_vypis = false; 
    public boolean[] generuje_sa = {false};
    public JButton Generuj;
    public JLabel lab_info;
    public Lsystem3D applet=null;
    public Lsystem3DForm form=null;
	public boolean shadow=true;
	public boolean ground=true;
	public int bgcolor=0x97CBFF;
	
	
	/** Creates a new instance of MyPanel */
	public MyPanel()
	{
	//	this.setBackground(new Color(255,0,0));
	//	this.setDoubleBuffered(false);
		_width = getWidth();
		_height = getHeight();
		_image = Toolkit.getDefaultToolkit().createImage(this);
		_model = new DirectColorModel(32,0x00FF0000,0x000FF00,0x000000FF,0);
		addMouseListener(this);
		addMouseMotionListener(this);
		modelView.set(cam.getMatrix());
	}
	
	public void run()
	{
		try{
        if(set_vypis)
        {
            vykresluje_sa = true;
            if(applet!=null)
            {
                if(applet.jazyk_slovak.isSelected())
                {
                    lab_info.setText(applet.j.slovak.info_vykres_retazec);
                }
                else
                {
                    lab_info.setText(applet.j.english.info_vykres_retazec);
                }
                
            }
            else if(form!=null)
            {
                if(form.jazyk_slovak.isSelected())
                {
                    lab_info.setText(form.j.slovak.info_vykres_retazec);
                }
                else
                {
                    lab_info.setText(form.j.english.info_vykres_retazec);
                }
            }
        }
        GL gl;
		Device2D dv2=null;
		if(antialiasing)
		{
			gl = new GL(2*_width,2*_height);
			gl.glLineWidth(3);
			dv2 = new Device2D(_width,_height);
		}
		else
			gl = new GL(_width,_height);
	
     //   Lsystem lsys = new Lsystem();
     //   lsys.k.gl = gl;
     //   lsys.Vytvor(1.f);
		if(lsys!=null)
			lsys.kk.gl = gl;
		
		long time = System.currentTimeMillis();
		frame = 0;
		fps = -1;

		mat m = new mat();
		
		gl.glSetPerspective(45.f);
		
		gl.glLightModelAmbient(0x303030);
	//	gl.glEnableLighting();
		Material mat = new Material();
		mat.ambient = 0xffffff;
		mat.diffuse = 0xffffff;
		mat.specular = 0xffffff;
		mat.shininess = 32.f;
		gl.glMaterial(mat);
		Light light = new Light();
		light.ambient = 0;
		light.diffuse = 0xffffff;
		light.specular = 0xffffff;
		if(shadow&&ground)
		{
			light.position.set(-1,1,1);
			light.position.Normalize();
			light.isObjectSpace = true;
		}
		else
		{
			light.position.set(0,0,1);
			light.isObjectSpace = false;			
		}
		light.directional = true;
		gl.glAddLight(light);

		Sphere sp = new Sphere();
		sp.Init(8,16,0.4f);
		
	/*	if(!mouseDrag)
		{
			cam.vcp.set(lsys.stred);
		//	cam.vp.set(v.sub(cam.vcp,v.mul(cam.vd,cam.vpd)));
			cam.moveWorld(0,0,false,false);
			modelView.set(cam.getMatrix());
		}*/

		do
		{
			frame++;
			if(valce)
				gl.clearColorBufferZbuf(bgcolor);
			else
				gl.clearColorBuffer(bgcolor);
		
			if(lsys!=null)
			{				
				if(rotuj && !mouseDrag)
				{
					cam.moveWorld(100.f/fps,0,true,false);
					modelView.set(cam.getMatrix());
					gl.glLoadViewMatrix(modelView);
				}
				else
					gl.glLoadViewMatrix(modelView);
				
				if(valce)
					gl.glEnableZBuffer();
				if(ground) //&& !(mouseDrag&&lineModeDrag))
				{
					gl.glDisableCullFace();
					gl.glShadeModel(gl.GL_FLAT);
					gl.glDisableLighting();
					gl.glColor3f(0.8f, 0.57f, 0);
					for(int z=0; z<4; z++)
					{
						float z0 = (float)z*5.f-10.f;
						float z1 = (float)(z+1)*5.f-10.f;
						gl.glBegin(GL.GL_TRIANGLE_STRIP);
						gl.glVertex3f(-10,-0.05f, z0);
						gl.glVertex3f(-10,-0.05f, z1);
						for(int x=1; x<5; x++)
						{
							float xf = (float)x*5.f-10.f;
							gl.glVertex3f(xf,-0.05f, z0);
							gl.glVertex3f(xf,-0.05f, z1);
						}
						gl.glEnd();
					}
				}
				
				if(valce)
				{
					if(mouseDrag&&lineModeDrag)gl.glPolygonModeLine();
					if(mouseDrag&&lineModeDrag)
					{
						gl.glPolygonModeLine();
						gl.glDisableZBuffer();
					}
					else
						gl.glEnableZBuffer(); 
					gl.glEnableCullFace();
					gl.glCullFaceFront();
					if(shadow && ground && (!mouseDrag || !lineModeDrag))
					{
						m.set(modelView);
						mat mt = new mat();
						mt.Identity();
						mt.Scale(1,0,1);
						mt.m12 = 0.5f;
						mt.m32 = -0.5f;
						m.mul(mt);
						gl.glColor3f(0.8f*0.6f,0.57f*0.6f,0);
						gl.glDisableLighting();
						gl.glLoadViewMatrix(m);
						gl.glShadeModel(gl.GL_FLAT);
						lsys.kk.Kresli(true,true);
						gl.glLoadViewMatrix(modelView);
						m.set(modelView);
						m.Translate(-15.f, 15.f, 15.f);
						gl.glLoadViewMatrix(m);
						gl.glColor3f(1,1,0.7f);
						sp.Draw(gl);
					}
					gl.glLoadViewMatrix(modelView);
					gl.glShadeModel(gl.GL_SMOOTH);
					gl.glRecomputeLightPositions();
					gl.glEnableLighting();
					lsys.kk.Kresli(true,true);
					gl.glPolygonModeTriangle();
				}
				else
				{
					gl.glDisableZBuffer();
					gl.glShadeModel(gl.GL_FLAT);
					gl.glDisableLighting();
					lsys.kk.Kresli_line(true);
				}
			}

			if(dv2!=null)
			{
				dv2.makeHalfSize(gl.cBuf);
				try{update(dv2.cBuf);}
                catch(Exception e) {}
			}
			else
				try{update(gl.cBuf);}
                catch(Exception e) {}
			//JOptionPane.showMessageDialog(null,String.valueOf(generuje_sa[0]),"Chyba",JOptionPane.ERROR_MESSAGE);
            if(!generuje_sa[0] && set_vypis)
            {
                vykresluje_sa = false;
                Generuj.setIcon(null);
                if(applet!=null)
                {
                    if(applet.jazyk_slovak.isSelected())
                    {
                        Generuj.setText(applet.j.slovak.button_generuj);
                    }
                    else
                    {
                        Generuj.setText(applet.j.english.button_generuj);
                    }
                }
                else if(form!=null)
                {
                   if(form.jazyk_slovak.isSelected())
                    {
                        Generuj.setText(form.j.slovak.button_generuj);
                    }
                    else
                    {
                        Generuj.setText(form.j.english.button_generuj);
                    }
                }
                lab_info.setText("");
                set_vypis = false;
            }
			if(rotuj || mouseDrag)
			{
				if(System.currentTimeMillis() - time > 0)
				{
				//	System.out.println(Long.toString(System.currentTimeMillis() - time));
					float minTime = 0.001f*(float)(System.currentTimeMillis() - time);
					if(fps<0)
						fps = (float)frame/minTime;
					else
						fps = 0.1f*(float)frame/minTime + 0.9f*fps;;
					frame = 0;
					time = System.currentTimeMillis();
				}
			}
		}while(rotuj || mouseDrag);
        } catch(OutOfMemoryError error) 
        {
            try{wait(100);} catch(Exception e) {}
            JOptionPane.showMessageDialog(null,"Out of Memory","Error",JOptionPane.ERROR_MESSAGE);
            applet.click.stop();
            applet.click.iteracia=0;
            applet.click.GenerujRetazec(0, 0);
        }
	}
	
	public int resizePanel(int width, int height)
	{
		int started = 0;
		if (_thread!=null)
		{
			stop();
			started = 1;
		}
		_width = width;
		_height = height;
		if(_consumer!=null)
			_consumer.setDimensions(_width,_height);
		_image = Toolkit.getDefaultToolkit().createImage(this);
		return started;
	}
	public synchronized void setBounds(int x, int y, int width, int height)
	{
		try{wait(20);} catch(InterruptedException e){}
        int started = resizePanel(width,height);
		super.setBounds( x, y, width, height);
		if(started==1)start();
	}
	public void setBounds(Rectangle r)
	{
		int started = resizePanel(r.width,r.height);
		super.setBounds(r);
		if(started==1)start();
	}
	public void setSize(Dimension d)
	{
		int started = resizePanel(d.width,d.height);
		super.setSize(d);
		if(started==1)start();
	}
	public void setSize(int width,int height)
	{
		int started = resizePanel(width,height);
		super.setSize(width,height);
		if(started==1)start();		
	}

	public void start()
	{
        if (_thread==null)					// check thread
        {
			_thread = new Thread(this);		// create thread
            _thread.setPriority(Thread.MIN_PRIORITY);
            _thread.start();				// start thread
        }		
	}
	
	public void stop()
	{
		if (_thread!=null && _thread.isAlive())		// check thread is valid and alive
		{
			try{_thread.stop();}	// stop thread
            catch (SecurityException e) {}
        }
		_thread = null;			// null thread
	}
	
	public synchronized void addConsumer(java.awt.image.ImageConsumer ic)
	{
		// register image consumer
		_consumer = ic;

		// set image dimensions
		_consumer.setDimensions(_width,_height);

		// set image consumer hints for speed
		_consumer.setHints(ImageConsumer.TOPDOWNLEFTRIGHT|ImageConsumer.COMPLETESCANLINES|ImageConsumer.SINGLEPASS|ImageConsumer.SINGLEFRAME);

		// set image color model
		_consumer.setColorModel(_model);
	}
	
	public synchronized boolean isConsumer(java.awt.image.ImageConsumer ic)
	{
		// check if consumer is registered
		return true;
	}
	
	public synchronized void removeConsumer(java.awt.image.ImageConsumer ic)
	{
		// remove image consumer
	}
	
	public void requestTopDownLeftRightResend(java.awt.image.ImageConsumer ic)
	{
		// ignore resend request
	}
	
	public synchronized void startProduction(java.awt.image.ImageConsumer ic)
	{
		// add consumer
		addConsumer(ic);
	}
	
	public synchronized void update(int[] pixels)
	{
		// check consumer
		if (_consumer!=null && pixels.length==_width*_height )
		{
			// copy integer pixel data to image consumer
			_consumer.setPixels(0,0,_width,_height,_model,pixels,0,_width);

			// notify image consumer that the frame is done
			_consumer.imageComplete(ImageConsumer.SINGLEFRAMEDONE);
		}

		// paint
		if(_image!=null)
		{
			Graphics g = getGraphics();
			g.drawImage(_image,0,0,_width,_height,null);
			
		/*	if(rotuj || mouseDrag)
			{
				g.setColor(new Color(255,255,255));
			//	g.fillRect(10,3, 100, 15);
			//	g.setColor(new Color(0,0,0));
				g.drawString(Float.toString(fps), 15, 15);
			}*/
		}
	}
	public synchronized void paint(Graphics g)
	{
		if(_image!=null)
		{
			g.drawImage(_image,0,0,_width,_height,null);
			
		/*	if(rotuj || mouseDrag)
			{
				g.setColor(new Color(255,255,255));
			//	g.fillRect(10,3, 70, 15);
			//	g.setColor(new Color(0,0,0));
				g.drawString(Float.toString(fps), 15, 15);
			}*/
		}		
	}
	public void mouseClicked(java.awt.event.MouseEvent e)
	{	// klik mysov
	}
	
	public void mouseEntered(java.awt.event.MouseEvent e)
	{	// vstup mysi do komponentu
	}
	
	public void mouseExited(java.awt.event.MouseEvent e)
	{	// vystup mysi s komponentu
	}
	
	public void mousePressed(java.awt.event.MouseEvent e)
	{	// stlacenie tlacitka
		mp_start.set(e.getX(),e.getY());
		mouseDrag = true;
		
		if (_thread==null)
			start();
		else if(!_thread.isAlive())
		{
			stop();	
			start();			
		}
	}
	
	public void mouseReleased(java.awt.event.MouseEvent e)
	{	// pustenie tlacitka
		mouseDrag = false;
		if(!rotuj)
		{
			stop();
			if(lineModeDrag)
				start();
		}
	}
	
	public synchronized void mouseDragged(java.awt.event.MouseEvent e)
	{	// stlacenie a tahanie
		mp_actual.set(e.getX(),e.getY());
		mp = vi.sub(mp_actual,mp_start);
		mp_start.set(mp_actual);
		cam.moveWorld(mp.x, mp.y, (e.getModifiersEx()&e.BUTTON1_DOWN_MASK)!=0, (e.getModifiersEx()&e.BUTTON3_DOWN_MASK)!=0);
		modelView.set(cam.getMatrix());
	}
	
	public void mouseMoved(java.awt.event.MouseEvent e)
	{	// posun bez stlacenia
	}

}
