/*
 * Jazyk.java
 *
 * Created on Utorok, 2004, november 16, 22:18
 */

package jazyk;

/**
 *
 * @author  Peter Ovarik
 */
public class Jazyk
{
    public Slovak slovak;
    public English english;
    
    public Jazyk()
    {
        slovak = new Slovak();
        english = new English();
    }
    
    public class Slovak
    {
        public String 
            // hlavne okno
            combo_kategoria_popis = "Kategoria:",
            combo_lsystem_popis = "L-system:",
            
            checkBox_lsystem = "Editovat L-system",
            checkBox_zobr_homo = "Zobraz. homomorf.",
            checkBox_zobr_retaz = "Zobrazovat retazec",
            
            text_lsystem_popis = "Vygenerovany retazec:",
            text_homo_popis = "Vygenerovany retazec homomorfizmu:",
            
            button_nastavenia = "Nastavenia",
            button_reset = "0",
            button_generuj = "Generuj",
            
            iteracia_popis = "Iteracia:",
            
            checkBox_rotuj = "Rotovat",
            checkBox_antialiasing = "Antialiasing",
            checkBox_valce = "Valce",
            checkBox_homo = "Homomorfizmus",
            
            // dialog nastaveni:
            title = "Nastavenie grafiky",
            button_zrusit = "Zrusit",
            button_pouzit = "Pouzit",
            checkBox_farba = "Pouzivat farbu pozadia:",
            checkBox_zem = "Kreslit zem",
            checkBox_tiene = "Zobrazovat tiene",
            checkBox_default_iter = "Pouzivat predvolenu iteraciu",
            checkBox_default_valce = "Pouzivat predvolene nastavenie valcov",
            checkBox_urychlovanie = "Urychlovat rotacie mysou",
        
            // informacny vypis pocas generovania a vykreslovania L-systemu
            info_gen_retazec = "Generuje sa retazec",
            info_gen_retazec1 = "Generujem retazec...",
            info_itrepret_retazec = "Interpretuje sa retazec",
            info_vykres_retazec = "Vykresluje sa L-system",
            info_prerusena_interpr_ret = "Prerusena iterpret. ret.!",
            info_dlzka_retazca = "Dlzka retazca:",
        
            // chybove hlasenia
            chyba = "Chyba",
            chyba_iter1 = "Zadaj platne cele cislo v kolonke \"Iteracia\"",
            chyba_iter2 = "Iteracia musi byt minimalne 0",
            chyba_malo_pamati = "Nedostatok pamati! L-sytem nie je mozne vygenerovat s danou iteraciou.";
    }
    
    public class English
    {
        public String 
            // hlavne okno
            combo_kategoria_popis = "Category:", // "Kategoria:",
            combo_lsystem_popis = "L-system:",   // "L-system:",
            
            checkBox_lsystem = "Edit L-sytem",      // "Editovat L-system",
            checkBox_zobr_homo = "Show homomorph.",    // "Zobraz. homomorf.",
            checkBox_zobr_retaz = "Show string",   // "Zobrazovat retazec",
            
            text_lsystem_popis = "String:",    // "Vygenerovany retazec:",
            text_homo_popis = "String with homomorphism:",       // "Vygenerovany retazec homomorfizmu:",
            
            button_nastavenia = "Settings",     // "Nastavenia",
            button_reset = "0",          // "Reset",
            button_generuj = "Make",        // "Generuj",
            
            iteracia_popis = "Order:",        // "Iteracia",
            
            checkBox_rotuj = "Rotate",        // "Rotovat",
            checkBox_antialiasing = "Antialiasing", // "Antialiasing",
            checkBox_valce = "Cylinders",        // "Valce",
            checkBox_homo = "Homomorphism",         // "Homomorf.",
            
            // dialog nastaveni:
            title = "Graphics settings",     // "Nastavenie grafiky",
            button_zrusit = "Cancel",        // "Zrusit",
            button_pouzit = "Apply",         // "Pouzit",
            checkBox_farba = "Use background color:",        // "Pouzivat farbu pozadia:",
            checkBox_zem = "Draw ground",          // Kreslit zem",
            checkBox_tiene = "Draw shadows",        // "Zobrazovat tiene",
            checkBox_default_iter = "Use preset iteation", // "Pouzivat predvolenu iteraciu",
            checkBox_default_valce = "Use preset cylinders",// "Pouzivat predvolene nastavenie valcov",
            checkBox_urychlovanie = "Faster mouse rotate", // "Urychlovat rotacie mysou",
        
            // informacny vypis pocas generovania a vykreslovania L-systemu
            info_gen_retazec = "Generating string",              // "Generuje sa retazec",
            info_gen_retazec1 = "String is generating...",             // "Generujem retazec.",
            info_itrepret_retazec = "Interpreting string",      // "Interpretuje sa retazec",
            info_vykres_retazec = "Drawing L-system",           // "Vykresluje sa L-system",
            info_prerusena_interpr_ret = "Interrupted",    // "Prerusena iterpret. ret.!";
            info_dlzka_retazca = "String length:", // Dlzka retazca
            
            // chybove hlasenia
            chyba = "Error",                     // "Chyba",
            chyba_iter1 = "Insert valid number", // "Zadaj platne cele cislo v kolonke \"Iteracia\"",
            chyba_iter2 = "Iteration must by minimal 0", // "Iteracia musi byt minimalne 0"
            chyba_malo_pamati = "Out of memory!";// "Nedostatok pamati! L-sytem nie je mozne vygenerovat s danou iteraciou.";
    }
}
