/*
 * KorytMinMax.java
 *
 * Created on tvrtok, 2004, november 4, 0:17
 */

package lsystem.korytnacka;
import graphics.math.*;
/**
 *
 * @author  m
 */
public class KorytMinMax extends Koryt
{
	public v min = new v();
	public v max = new v();
	
	/** Creates a new instance of KorytMinMax */
	public KorytMinMax()
	{
		super();
	}
	public void Reset()
	{
		super.Reset();	
		min.clear();
		max.clear();
	}
	void porovnaj()
	{
		if(stav.p.x>max.x)max.x=stav.p.x;
		if(stav.p.y>max.y)max.y=stav.p.y;
		if(stav.p.z>max.z)max.z=stav.p.z;

		if(stav.p.x<min.x)min.x=stav.p.x;
		if(stav.p.y<min.y)min.y=stav.p.y;
		if(stav.p.z<min.z)min.z=stav.p.z;
	}
	public void F( float dlzka)
	{
		super.F( dlzka);
		porovnaj();
	}
	public void F( float dlzka, float hrubka)
	{
		super.F( dlzka, hrubka);
		porovnaj();
	}
	public void f( float dlzka)
	{
		super.f(dlzka);
		porovnaj();
	}
	public void G( float dlzka)
	{
		super.G(dlzka);
		porovnaj();
	}
	public void g( float dlzka)
	{
		super.g(dlzka);
		porovnaj();
	}
}
