/*
 * Nastavenia.java
 *
 * Created on Nedee, 2004, november 14, 14:13
 */

/**
 *
 * @author  Peter Ovarik
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import javax.naming.*;
import javax.swing.*;
import javax.swing.border.*; 
import javax.swing.text.*;
import java.io.*;
import javax.swing.ImageIcon.*;
import javax.swing.colorchooser.*;

public class Nastavenia extends javax.swing.JFrame
{
    Lsystem3D applet=null;
    Lsystem3DForm form=null;
    
    //public Nastavenia dialog;
    JButton OK;
    JButton Zrusit;
    JButton Bg_color;
    JCheckBox farba_pozadia;
    JCheckBox zobrazovat_tiene;
    JCheckBox default_iter;
    JCheckBox kreslit_zem;
    JCheckBox default_valce;
    JCheckBox urychlovanie;
    JButton Pouzit;
    
    public boolean bool_farba_pozadia = false;
    public boolean bool_zobrazovat_tiene = true;
    public boolean bool_default_iter = true;
    public boolean bool_kreslit_zem = true;
    public boolean bool_default_valce = true;
    public boolean bool_urychlovanie = true;
    private int bg_color = 0x000000;
    public int int_bg_color = bg_color;
    
    public Nastavenia()
    {
        initComponents();
        this.setTitle("Nastavenie grafiky");
    }
    
    public void initComponents()
    {
        getContentPane().setLayout(null);
        Click click = new Click();
        
        OK = new JButton("OK");
        getContentPane().add(OK); OK.setBounds(35,170,73,23);
        OK.addActionListener(click);
        
        Zrusit = new JButton("Zrusit");
        getContentPane().add(Zrusit); Zrusit.setBounds(35+77,170,73,23);
        Zrusit.addActionListener(click);
        
        Pouzit = new JButton("Pouzit");
        getContentPane().add(Pouzit); Pouzit.setBounds(35+2*77,170,73,23);
        Pouzit.addActionListener(click);
        
        Bg_color = new JButton("");
        getContentPane().add(Bg_color); Bg_color.setBounds(178,16,20,18);
        Bg_color.addActionListener(click);
        Bg_color.setBackground(new Color(bg_color));
        
        farba_pozadia = new JCheckBox("Pouzivat farbu pozadia:");
        getContentPane().add(farba_pozadia); farba_pozadia.setBounds(20,15,158,20);
        farba_pozadia.addActionListener(click);
        if(bool_farba_pozadia)
        {
            farba_pozadia.setSelected(true);
            Bg_color.setEnabled(true);
        }
        else 
        {
            farba_pozadia.setSelected(false);
            Bg_color.setEnabled(false);
        }
        
        kreslit_zem = new JCheckBox("Kreslit zem");
        getContentPane().add(kreslit_zem); kreslit_zem.setBounds(20,15+1*22,100,20);
        kreslit_zem.addActionListener(click);
        if(bool_kreslit_zem) kreslit_zem.setSelected(true);
        else kreslit_zem.setSelected(false);
        
        zobrazovat_tiene = new JCheckBox("Zobrazovat tiene");
        getContentPane().add(zobrazovat_tiene); zobrazovat_tiene.setBounds(20,15+2*22,120,20);
        zobrazovat_tiene.addActionListener(click);
        if(bool_zobrazovat_tiene) zobrazovat_tiene.setSelected(true);
        else zobrazovat_tiene.setSelected(false);
        
        default_iter = new JCheckBox("Pouzivat predvolenu iteraciu");
        getContentPane().add(default_iter); default_iter.setBounds(20,15+3*22,200,20);
        default_iter.addActionListener(click);
        if(bool_default_iter) default_iter.setSelected(true);
        else default_iter.setSelected(false);
        
        default_valce = new JCheckBox("Pouzivat predvolene nastavenie valcov");
        getContentPane().add(default_valce); default_valce.setBounds(20,15+4*22,250,20);
        default_valce.addActionListener(click);
        if(bool_default_valce) default_valce.setSelected(true);
        else default_valce.setSelected(false);
        
        urychlovanie = new JCheckBox("Urychlovat rotacie mysou");
        getContentPane().add(urychlovanie); urychlovanie.setBounds(20,15+5*22,190,20);
        urychlovanie.addActionListener(click);
        if(bool_urychlovanie) urychlovanie.setSelected(true);
        else urychlovanie.setSelected(false);
                
        this.setSize(300, 255);
    }
    
    public void Update_settings()
    {
        bool_farba_pozadia = farba_pozadia.isSelected();
        bool_zobrazovat_tiene = zobrazovat_tiene.isSelected();
        bool_default_iter = default_iter.isSelected();
        bool_kreslit_zem = kreslit_zem.isSelected();
        bool_default_valce = default_valce.isSelected();
        bool_urychlovanie = urychlovanie.isSelected();
        int_bg_color = bg_color;
        if(applet!=null) applet.Update_settings();
        else if(form!=null) form.Update_settings();
    }
    
    public class Click implements ActionListener
  	{
        public void actionPerformed(ActionEvent e)
        {
            if(e.getSource() == OK)
            {  
				Update_settings();
                hide();                
            }
            
            if(e.getSource() == Zrusit)
            {
                hide();
            }
            
            if(e.getSource() == Pouzit)
            {
                Update_settings();
            }
            
            if(e.getSource() == Bg_color)
            {
                JColorChooser color_dialog = new JColorChooser();
                Color color = new Color(0x000000);
                if(applet!=null) color = color_dialog.showDialog(applet.dial_nast, "Farba pozadia", new Color(bg_color));
                else if(form!=null) color = color_dialog.showDialog(form.dial_nast, "Farba pozadia", new Color(bg_color));
                
                if(color!=null)
                {
                    bg_color = color.getRGB();
                    Bg_color.setBackground(color);
                }
            }
            
            if(e.getSource() == farba_pozadia)
            {
                Bg_color.setEnabled(farba_pozadia.isSelected());
            }
            
            if(e.getSource() == zobrazovat_tiene)
            {
                
            }
            
            if(e.getSource() == default_iter)
            {
                
            }
            
            if(e.getSource() == kreslit_zem)
            {
                
            }
            
            if(e.getSource() == default_valce)
            {
                
            }
            
            if(e.getSource() == urychlovanie)
            {
                
            }
        }
    }
}    

