/*
 * Koryt_Listy.java
 *
 * Created on Streda, 2004, oktber 20, 15:48
 */

/**
 *
 * @author Marek Mizanin
 */
package lsystem.korytnacka;

import graphics.math.*;
import graphics.device.*;
import java.util.*;

class z_Line
{
	v			a,b;
	int			color;			// aktualny farba
	float		hrubka;
	public z_Line()
	{
		a = new v();
		b = new v();
		color = 0xffffff;
	}
};

public class Koryt_Line extends Koryt
{
	private Vector line;
	public void Reset()
	{
		super.Reset();
		line.clear();
	}
	public void Kresli_line(boolean color)
	{
		for(int i=0; i<line.size(); i++)	// prechadzame cez vsetky ciary
		{
			gl.glColor3fv(((z_Line)line.get(i)).color);	// farba
		//	gl.glLineWidth(((z_Line)line.get(i)).hrubka);	// hrubka
			gl.glBegin(gl.GL_LINES);					// kreslime ciary
			gl.glVertex3fv( ((z_Line)line.get(i)).a );		// prvy bod ciary
			gl.glVertex3fv( ((z_Line)line.get(i)).b );		// druhy bod ciary
			gl.glEnd();
		}
	}
	
	public void F( float dlzka)
	{
		z_Line a = new z_Line();

		a.a.set(stav.p);
		a.color = stav.color;
		a.hrubka = stav.hrubka*dlzka*stav.dlzka;			// hrubka je umerna dlzke, dlzku musim upravit podla akt. stavu
		super.F( dlzka);
		a.b.set(stav.p);
		line.add(a);
	}
	public void F( float dlzka, float hrubka)
	{
		z_Line a = new z_Line();

		a.a.set(stav.p);
		a.color = stav.color;
		a.hrubka = hrubka*dlzka*stav.dlzka;			// hrubka je umerna dlzke, dlzku musim upravit podla akt. stavu
		super.F( dlzka, hrubka);
		a.b.set(stav.p);
		line.add(a);
	}
	public void G( float dlzka)
	{
		z_Line a = new z_Line();

		a.a.set(stav.p);
		a.color = stav.color;
		a.hrubka = stav.hrubka*dlzka*stav.dlzka;			// hrubka je umerna dlzke, dlzku musim upravit podla akt. stavu
		super.G( dlzka);
		a.b.set(stav.p);
		line.add(a);
	}
	
	public Koryt_Line()
	{
		super();
		line = new Vector();
	}
}
