/*
 * Koryt_Listy.java
 *
 * Created on Pondelok, 2004, november 8, 19:18
 */

package lsystem.korytnacka;
import graphics.math.*;
import graphics.device.*;
import java.util.*;
/**
 *
 * @author  Marek Mizanin
 */
class z_list			// struktura popisujuca list, t.j. polygon vytvarany cez {}
{
	v n;				// normalovy vektor
	Vector ve;		// pole vrcholov polygonu
//	vector<vec2> t;		// texturove suradnice
	v h,r;			// vektory head a -left, pri zadani prveho bodu
//	vec2 t_posun,t_mierka;
//	unsigned int	texture_id;		// id aktualnej textury, ak==0 texturovanie je vypnute
//	unsigned char	texture_env;	// GL_MODULATE(0), alebo GL_DECAL(1)
	Material		mat;			// aktualny material, nemoze sa rovnat NULL
	Material		mat_back;		// aktualny vnutorny material,   moze sa rovnat NULL
	int				colorDiffuse;
	public z_list()
	{
		ve = new Vector();
		n = new v();
		h = new v();
		r = new v();
	}
};

public class Koryt_Listy extends Koryt_Gule
{
	Vector listy;		// pole listov, kazdy list je polev vrcholov
	Stack zas_list;		// zasobnik pre listy
	
	public Koryt_Listy()
	{
		listy = new Vector();
		zas_list = new Stack();
	}
	public void Reset()
	{
		super.Reset();
		listy.clear();
		zas_list.clear();
	}
	z_list listy(int i)
	{
		return (z_list)listy.get(i);
	}
	public void Kresli(boolean color, boolean light)
	{
		super.Kresli(color, light);
	//	if(light)gl.glEnableLighting();		// zapne svetlo ak je light==1
	//	else gl.glDisableLighting();
		boolean cullFace = gl.cullFace;
		gl.glEnableCullFace();
		// glLightModelf( GL_LIGHT_MODEL_TWO_SIDE, 1.0f);

		for(int i=0; i<listy.size(); i++)
		{
		//	if(light&&color)
		//	{
			/*	if(listy(i).mat_back!=null)
				{
					listy(i).mat->setFront();
					listy[i].mat_back->setBack();
				}
				else
					listy[i].mat->set();*/
		//	}
		/*	if(listy[i].texture_id!=0)
			{
				if(listy[i].texture_id!=texture_id)
				{
					if(!texture_id)glEnable(GL_TEXTURE_2D);
					glBindTexture( GL_TEXTURE_2D, listy[i].texture_id);
					texture_id = listy[i].texture_id;
				}
				if(listy[i].texture_env)glDisable(GL_LIGHTING);

			//	glBegin(GL_TRIANGLE_STRIP);
			//	glBegin(GL_LINE_STRIP);
				glBegin(GL_POLYGON);
				glNormal3fv(listy[i].n.v);
				for(int j=0; j<listy[i].v.size(); j++)
				{
					glTexCoord2fv( listy[i].t[j].v );
					glVertex3fv( listy[i].v[j].v );
				}
				glTexCoord2fv( listy[i].t[0].v );
				glVertex3fv( listy[i].v[0].v );
				glEnd();
			}
			else
			{
				if(texture_id!=0)
				{
					glDisable(GL_TEXTURE_2D);
					texture_id = 0;
				}*/
			//	glBegin(GL_TRIANGLE_STRIP);
			//	glBegin(GL_LINE_STRIP);
			//	gl.glBegin(GL.GL_POLYGON);
				gl.glMaterial(((z_list)listy.get(i)).mat);
				gl.material.diffuse = ((z_list)listy.get(i)).colorDiffuse;
			
				gl.glBegin(GL.GL_TRIANGLE_FAN);
				gl.glNormal3fv(((z_list)listy.get(i)).n);
				for(int j=0; j<((z_list)listy.get(i)).ve.size(); j++)
					gl.glVertex3fv( (v)((z_list)listy.get(i)).ve.get(j) );
				gl.glEnd();
				
				if(listy(i).mat_back!=null)
					gl.glMaterial(((z_list)listy.get(i)).mat_back);

				gl.glBegin(GL.GL_TRIANGLE_FAN);
				gl.glNormal3fv(v.neg(((z_list)listy.get(i)).n));
				gl.glVertex3fv( (v)((z_list)listy.get(i)).ve.get(0) );
				for(int j=((z_list)listy.get(i)).ve.size()-1; j>0; j--)
					gl.glVertex3fv( (v)((z_list)listy.get(i)).ve.get(j) );
				gl.glEnd();
		//	}
		}
		
//		glLightModelf( GL_LIGHT_MODEL_TWO_SIDE, 0.0f);	// jednostranne osvetlenie
	//	if(light)gl.glDisableLighting();
	//	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
		gl.cullFace = cullFace;
	}
	void Vypocitaj_nomaly()
	{
		for(int i=0; i<listy.size(); i++)
		{
			z_list li = ((z_list)listy.get(i));
			
			if(li.ve.size()<3)
				li.n.set(0,0,1);
			else
				li.n.set(v.MakeNormal((v)li.ve.get(0),(v)li.ve.get(1),(v)li.ve.get(2)));
		}
	}
	public void Koncove_vypocty()
	{
		super.Koncove_vypocty();
		Vypocitaj_nomaly();
	//	for(int i=0; i<listy.size(); i++) Vypocitaj_tex_koord( listy[i]);
	}
	public void F( float dlzka)
	{
		super.F(dlzka);
		Pridaj_vrchol();
	}

	public void F( float dlzka, float hrubka)
	{
		super.F(dlzka, hrubka);
		Pridaj_vrchol();
	}

	public void f( float dlzka)
	{
		super.f( dlzka);
		// + mod zaznamu polygonov
		Pridaj_vrchol();
	}
	public void zat_zloz_otv()					// {
	{
		super.zat_zloz_otv();
		z_list l = new z_list();
		l.mat = stav.mat;
		l.mat_back = stav.mat_back;
		l.colorDiffuse = stav.color;
	//	l.texture_id = stav.texture_id;
	//	l.texture_env = stav.texture_env;
		zas_list.push(l);						// vlozime prazdny list do zasobnika
	}
	public void zat_zloz_zat()					// }
	{
		super.zat_zloz_zat();
		if(!zas_list.empty())							// ak nieje zasobnik prazdny vyberieme zo zasobnika akt.
		{
			listy.add(zas_list.peek());			// pridame list na vrchole zasobnika do listov
			zas_list.pop();								// znizime zasobnik
		}
	}
	public void bodka()							// .
	{
		super.bodka();
		Pridaj_vrchol();
	}
	public void Pridaj_vrchol()
	{
		if(!zas_list.empty())
		{
			if(((z_list)zas_list.peek()).ve.size()!=0)
			{
				((z_list)zas_list.peek()).h.set(stav.h);
				((z_list)zas_list.peek()).r.set(v.neg(stav.l));
			//	((z_list)zas_list.peek()).t_mierka = stav.t_mierka;
			//	((z_list)zas_list.peek()).t_posun = stav.t_posun;
			}
			((z_list)zas_list.peek()).ve.add(new v(stav.p));
		}
	}
/*	public void Vypocitaj_tex_koord(z_list list)
	{
		vec p;
		vec2 t;
		float hmin,hmax,rmin,rmax;

		if(list->texture_id==0)return;
		mat4 m;
		m.MakeMatrix( list->r, list->h, CROSS( list->r, list->h));
		rmin=(float)1e+6;rmax=(float)-1e+6;
		hmin=(float)1e+6;hmax=(float)-1e+6;
		for(int j=0; j<list->v.size(); j++)
		{
			p = m*list->v[j];
			if(p.x<rmin)rmin=p.x;
			if(p.x>rmax)rmax=p.x;
			if(p.y<hmin)hmin=p.y;
			if(p.y>hmax)hmax=p.y;
		}
		rmax -= rmin; rmax = 1.f/rmax;
		hmax -= hmin; hmax = 1.f/hmax;
		for( j=0; j<list->v.size(); j++)
		{
			p = m*list->v[j];
			t.x = (p.x-rmin)*rmax;	// u = (r - rmin)/(rmax - rmin)
			t.y = (p.y-hmin)*hmax;	// v = (h - hmin)/(hmax - hmin)
			t.x *= list->t_mierka.x;  t.x += list->t_posun.x;
			t.y *= list->t_mierka.y;  t.y += list->t_posun.y;
			list->t.push_back( t );
		}
	}*/
}
