/*
 * Kstav.java
 *
 * Created on Streda, 2004, november 3, 22:58
 */

package lsystem.korytnacka;
import graphics.math.*;
import graphics.device.*;

/**
 *
 * @author  m
 */

/*             up               ja pouzivam otocenu o 90   A  heading (0,1,0)
               A   ^  heading                              |
               |  /                                        |
               | /                                         |
               |/                      left (-1,0,0) <-----+
   left  <-----+  position                                /
                                                         /
                                                        V   up (0,0,1)
*/
public class Kstav		// stav korytnacka
{
	public v		p;			// pozicia
	public v		h,l,u;		// hlavne vektory, vektor h - head - dopredu, l - left, u - up
	public float	dlzka;		// aktualna dlzka jedneho segmentu, pouziva sa na zmensenie celeho modelu
	public float	hrubka;		// aktualna hrubka, zodpoveda priemeru
	
	public float	uhol;		// aktualny uhol
//	public v2		t_posun;	// posun texturovych koordinacii
//	public v2		t_mierka;	// mierka texturovych koordinacii
	public v		minrot;		// referencny vektor pre minimalizaciu otocenia kontury, je vzdy kolmy na h vektor
	
	public z_kontura	kontura;		// aktualna kontura, nemoze sa rovnat null
//	public int			texture_id;		// id aktualnej textury, ak==0 texturovanie je vypnute
//	public char			texture_env;	// GL_MODULATE(0), alebo GL_DECAL(1)
	public Material	mat;			// aktualny material, nemoze sa rovnat null
	public Material	mat_back;		// aktualny vnutorny material, moze sa rovnat null
	public int color;				// farba pre ciary

/*	class z_gen
	{
		v	p;		// pozicia, posledny kontrolny bod, zapisuje sa s @Gs a @Gc
		v	h;		// head vektor, zapisuje sa s @Gs a @Gc
		v	right;	// right vektor, zapisuje sa s @Gs a @Gc, urcuje zaciatok kontury, but -h, alebo minrot
		float hrubka;	// hrubka, zapisuje sa s @Gs a @Gc, pouzije sa na interpolaciu hrubky
		z_kontura kontura;			// zapisuje sa s @Gs a @Gc
		float tan_start, tan_end;	// nastavuje dlzku smerovych vektorov nastavuje sa s @Gt(start, end)
		public z_gen()
		{
			p = new v();
			h = new v();
			right = new v();
			kontura = null;
		}
		public z_gen(z_gen a)
		{
			p = new v(a.p);
			h = new v(a.h);
			right = new v(a.right);
			hrubka = a.hrubka;
			kontura = a.kontura;
			tan_start = a.tan_start;
			tan_end = a.tan_end;
		}
	};
	public z_gen gen;*/
	
	public Kstav()
	{
		p = new v();
		h = new v();
		l = new v();
		u = new v();
	//	t_posun = new v2();
	//	t_mierka = new v2();
		minrot = new v();
	//	gen = new z_gen();
		clear();
	}
	public Kstav(Kstav a)
	{
		p = new v(a.p);
		h = new v(a.h);
		l = new v(a.l);
		u = new v(a.u);
		dlzka = a.dlzka;
		hrubka = a.hrubka;
		uhol = a.uhol;
		minrot = new v(a.minrot);
		kontura = a.kontura;
	//	texture_id = a.texture_id;
	//	texture_env = a.texture_env;
		mat = a.mat;
		mat_back = a.mat_back;
	//	gen = new z_gen(a.gen);
		color = a.color;
		
	}
	public void clear()
	{
		dlzka=1;
		p.clear();
		h.clear();
		l.clear();
		u.clear();
	//	h.z=-1;	u.y= 1;	l.x=-1;
		h.y= 1; u.z= 1; l.x=-1;
		dlzka = 1.0f;				// pouziva sa na zmensovanie celeho modelu tak aby sa vosiel do obrazovky
		hrubka = 0.3f;				// zodpoveda priemeru valcov
		uhol = 90.f;
	//	t_posun.x = 0.0f; t_posun.y = 0.f;
	//	t_mierka.x = 1.f; t_mierka.y = 1.f;
		minrot.set(1,0,0);
		
		kontura = null;
		mat = null;
		mat_back = null;
		color = 0xffffff;
	//	texture_id = 0;
	//	texture_env = 0;

	//	gen.p.clear();
	//	gen.h = h;
	//	gen.right = minrot;
	//	gen.hrubka = hrubka;
	//	gen.tan_start = 1.2f;
	//	gen.tan_end = 1.2f;
	}
};
